#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityDBFSignCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityDBFSignCFG> M_ActivityDBFSignCFG::msSingleton(nullptr);

int M_ActivityDBFSignCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityDBFSignCFGData* M_ActivityDBFSignCFG::GetData(int Day)
{
	auto it = mMapData.find(Day);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityDBFSignCFGData>& M_ActivityDBFSignCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityDBFSignCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityDBFSignCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityDBFSignCFGData data;
		data.mDay = element->IntAttribute("Day");
		{
			const char* RewardItem = element->Attribute("RewardItem");
			std::vector<std::string> vecRewardItem;
			boost::split(vecRewardItem, RewardItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardItem[i].c_str(), &temp))
				{
					data.mRewardItem.push_back(temp);
				}
			}
		}
		{
			const char* RewardQuantity = element->Attribute("RewardQuantity");
			std::vector<std::string> vecRewardQuantity;
			boost::split(vecRewardQuantity, RewardQuantity, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardQuantity.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardQuantity[i].c_str(), &temp))
				{
					data.mRewardQuantity.push_back(temp);
				}
			}
		}
		{
			const char* Display = element->Attribute("Display");
			std::vector<std::string> vecDisplay;
			boost::split(vecDisplay, Display, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecDisplay.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecDisplay[i].c_str(), &temp))
				{
					data.mDisplay.push_back(temp);
				}
			}
		}
		{
			const char* DisplayQuantity = element->Attribute("DisplayQuantity");
			std::vector<std::string> vecDisplayQuantity;
			boost::split(vecDisplayQuantity, DisplayQuantity, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecDisplayQuantity.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecDisplayQuantity[i].c_str(), &temp))
				{
					data.mDisplayQuantity.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mDay) != mMapData.end())std::cout <<"data refind:" << data.mDay << std::endl;
		assert(mMapData.find(data.mDay) == mMapData.end());
		mMapData.insert(std::make_pair(data.mDay, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityDBFSignCFG::Load()
{
	Load("../Config/M_ActivityDBFSignCFG.xml");
}

M_ActivityDBFSignCFG* M_ActivityDBFSignCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityDBFSignCFG());
	}
	return msSingleton.get();
}
